<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond_Benc
 * @package 		Phpfox_Component
 * @version 		$Id: controller.class.php 103 2009-01-27 11:32:36Z Raymond_Benc $
 */
class Apps_Component_Controller_Developer extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		$aMethods = array();
		$aCallbacks = Phpfox::massCallback('getApiSupportedMethods');
		
		foreach ($aCallbacks as $sModule => $aCallback)
		{
			foreach ($aCallback['methods'] as $iKey => $aMethod)
			{
				$aCallback['methods'][$iKey]['response'] = str_replace('[DOMAIN_REPLACE]', Phpfox::getParam('core.host'), str_replace('stdClass&nbsp;', '', highlight_string(print_r(json_decode($aMethod['response']), true), true)));
				
				$sUrl = '/api.php?method=' . $aCallback['module'] . '.' . $aMethod['call'] . '';
				if (isset($aMethod['requires']) && is_array($aMethod['requires']))
				{
					foreach ($aMethod['requires'] as $sRequireKey => $sRequireType)
					{
						$sUrl .= '&amp;' . $sRequireKey . '=#{' . strtoupper($sRequireType) . '}';
					}
				}
				$aCallback['methods'][$iKey]['url'] = $sUrl;
			}
			
			$aMethods[] = $aCallback;				
		}
		
		$this->template()->setTitle('App Developers')
			->setBreadcrumb('Apps', $this->url()->makeUrl('apps'))
			->setBreadcrumb('Developers', $this->url()->makeUrl('apps.developer'), true)
			->setFullSite()
			->setHeader(array(
					'apps.css' => 'style_css',
					'apps.js' => 'module_apps'
				)
			)
			->assign(array(
					'sSiteName' => Phpfox::getParam('core.site_title'),
					'aMethods' => $aMethods,
					'sSampleCall' => Phpfox::getParam('core.path') . 'api.php?public_key=#{PUBLIC_KEY}&amp;private_key=#{PRIVATE_KEY}&token=#{TOKEN}&amp;method=#{METHOD_NAME}'
				)
			);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('apps.component_controller_developer_clean')) ? eval($sPlugin) : false);
	}
}

?>