<?php 
/**
 * [PHPFOX_HEADER]
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond_Benc
 * @package 		Phpfox
 * @version 		$Id: controller.html.php 64 2009-01-19 15:05:54Z Raymond_Benc $
 */
 
defined('PHPFOX') or exit('NO DICE!'); 

?>
<div id="apps_developer_holder">
	<div class="apps_dev_menu">
		<ul>
			<li><a href="#" class="active js_apps_menu_click" rel="">Introduction</a></li>
		</ul>
		<div class="apps_dev_menu_title">
			API
		</div>	
		<ul>
		{foreach from=$aMethods item=aMethodModule}
			<li><a href="#" class="js_apps_menu_click" rel="{$aMethodModule.module|clean}">{$aMethodModule.module|clean}</a></li>
		{/foreach}
		</ul>
	</div>

	<div class="apps_dev_info">
		<div class="apps_module_holder apps_module_holder_main" id="js_apps_module_">
			<div class="p_bottom_10">
				As a developer you can create applications and add them to {$sSiteName}, taking 
				advantage of the existing user base. You host the application, which means that you are
				in full control of your server specifications (no worries about PHP version or SSL for
				example).
			</div>
			
			<div class="p_bottom_10">
				<h3>Setting up an APP</h3>
				To interact with {$sSiteName} your application can issue calls to our API and 
				request or post information.
				<p>
					When you <a href="{url link='apps.add'}">add an application</a> to our site we will give you a <b>public</b> and a <b>private key</b>. 
					Every call to the API requires that you pass both keys, as well as a <b>token</b> that is
					generated with every visit from the user and passed to your application via <b>GET</b> in the 
					iframe.
				</p>
			</div>
				
			<div class="p_bottom_10">
				<h3>Sending a Request</h3>
				<div class="p_bottom_5">
					An example call to our API server would look like:
				</div>
				<div class="apps_method_response">	
					{$sSampleCall}
				</div>
			</div>

			<div class="p_bottom_10">
				<h3>Understanding an API Response</h3>		
				<p>
					For methods that could return more than one item the response will contain an indicator
					of the total items available as well as how many pages there are. We return by default 10 items at most and
					in order to get the next 10 items you would have to pass the param "<b>page=2</b>".
				</p>
				<p>
					To the left you will find a list of the modules that implement API methods. Click on
					the module and you will see a list of the methods that your application can use. For
					shortness and formatting purposes we do not include the full request in there but 
					only the most relevant parts.
				</p>		
			</div>
		</div>
		{foreach from=$aMethods item=aMethodModule}
		<div class="apps_module_holder" id="js_apps_module_{$aMethodModule.module|clean}">
			<div class="apps_module_title">{$aMethodModule.module|clean}</div>
			{foreach from=$aMethodModule.methods item=aMethod}
			<div class="apps_method_holder">
				<div class="apps_method_title">
					{$aMethod.call|clean}
				</div>
				<div class="apps_method_type">
					{$aMethod.type}{if isset($aMethod.url)} {$aMethod.url}{/if}
				</div>
				<div class="apps_method_info">
					{$aMethod.detail|clean}
				</div>	
				{if !empty($aMethod.response)}
				<div class="apps_method_response_title">
					Response
				</div>
				<div class="apps_method_response">					
						{$aMethod.response}
				</div>
				{/if}
			</div>
			{/foreach}
		</div>
		{/foreach}
	</div>
</div>