<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Ajax
 * @version 		$Id: ajax.class.php 2592 2011-05-05 18:51:50Z Raymond_Benc $
 */
class Marketplace_Component_Ajax_Ajax extends Phpfox_Ajax
{
	public function delete()
	{
		if (Phpfox::getService('marketplace.process')->delete($this->get('id')))
		{
			$this->call('$(\'#js_mp_item_holder_' . $this->get('id') . '\').html(\'<div class="message" style="margin:0px;">' . Phpfox::getPhrase('marketplace.successfully_deleted_listing') . '</div>\').fadeOut(5000);');			
		}
	}
	
	public function setDefault()
	{
		if (Phpfox::getService('marketplace.process')->setDefault($this->get('id')))
		{
			
		}
	}
	
	public function deleteImage()
	{
		if (Phpfox::getService('marketplace.process')->deleteImage($this->get('id')))
		{
			
		}
	}

	public function listInvites()
	{
		Phpfox::getBlock('marketplace.list');
		
		$this->html('#js_mp_item_holder', $this->getContent(false));
	}

	public function feature()
	{
		if (Phpfox::getService('marketplace.process')->feature($this->get('listing_id'), $this->get('type')))
		{
			// js_mp_item_holder_4
			if ($this->get('type'))
			{
				$this->addClass('#js_mp_item_holder_' . $this->get('listing_id'), 'row_featured');
				$this->alert('Listing successfully featured', 'Feature', 300, 150, true);
			}
			else 
			{
				$this->removeClass('#js_mp_item_holder_' . $this->get('listing_id'), 'row_featured');
				$this->alert('Listing successfully un-featured', 'Un-Feature', 300, 150, true);
			}				
		}
	}	

	public function sponsor()
	{
	    if (Phpfox::getService('marketplace.process')->sponsor($this->get('listing_id'), $this->get('type')))
	    {
		if ($this->get('type') == '1')
		{
		    Phpfox::getService('ad.process')->addSponsor(array('module' => 'marketplace', 'item_id' => $this->get('listing_id')));
		    // listing was sponsored
		    $sHtml = '<a href="#" title="' . Phpfox::getPhrase('marketplace.unsponsor_this_listing') . '" onclick="$.ajaxCall(\'marketplace.sponsor\', \'listing_id=' . $this->get('listing_id') . '&amp;type=0\'); return false;">'.Phpfox::getPhrase('marketplace.unsponsor_this_listing').'</a>';
		}
		else
		{
		    Phpfox::getService('ad.process')->deleteAdminSponsor('marketplace', $this->get('listing_id'));
		    $sHtml = '<a href="#" title="' . Phpfox::getPhrase('marketplace.unsponsor_this_listing') . '" onclick="$.ajaxCall(\'marketplace.sponsor\', \'listing_id=' . $this->get('listing_id') . '&amp;type=1\'); return false;">'.Phpfox::getPhrase('marketplace.sponsor_this_listing').'</a>';
		}
		$this->html('#js_sponsor_' . $this->get('listing_id'), $sHtml)->alert($this->get('type') == '1' ? Phpfox::getPhrase('marketplace.listing_successfully_sponsored') : Phpfox::getPhrase('marketplace.listing_successfully_un_sponsored'));
		if($this->get('type') == '1')
		{
		    $this->addClass('#js_mp_item_holder_' . $this->get('listing_id'), 'row_sponsored');
		}
		else
		{
		    $this->removeClass('#js_mp_item_holder_' . $this->get('listing_id'), 'row_sponsored');
		}
	    }
	    //js_mp_item_holder_
	}

	public function approve()
	{
		if (Phpfox::getService('marketplace.process')->approve($this->get('listing_id')))
		{
			$this->alert('Listing has been approved.', 'Listing Approved', 300, 100, true);
			$this->hide('#js_item_bar_approve_image');
			$this->hide('.js_moderation_off'); 
			$this->show('.js_moderation_on');	
		}
	}
	
	public function moderation()
	{
		Phpfox::isUser(true);	
		
		switch ($this->get('action'))
		{
			case 'approve':
				Phpfox::getUserParam('marketplace.can_approve_listings', true);
				foreach ((array) $this->get('item_moderate') as $iId)
				{
					Phpfox::getService('marketplace.process')->approve($iId);
					$this->remove('#js_mp_item_holder_' . $iId);					
				}				
				$this->updateCount();
				$sMessage = 'Listing(s) successfully approved.';
				break;			
			case 'delete':
				Phpfox::getUserParam('marketplace.can_delete_other_listings', true);
				foreach ((array) $this->get('item_moderate') as $iId)
				{
					Phpfox::getService('marketplace.process')->delete($iId);
					$this->slideUp('#js_mp_item_holder_' . $iId);
				}				
				$sMessage = 'Listing(s) successfully deleted.';
				break;
			case 'feature':
				Phpfox::getUserParam('marketplace.can_feature_listings', true);
				foreach ((array) $this->get('item_moderate') as $iId)
				{
					Phpfox::getService('marketplace.process')->feature($iId, 1);
					$this->addClass('#js_mp_item_holder_' . $iId, 'row_featured');
				}				
				$sMessage = 'Listing(s) successfully featured.';
				break;
			case 'un-feature':
				Phpfox::getUserParam('marketplace.can_feature_listings', true);
				foreach ((array) $this->get('item_moderate') as $iId)
				{
					Phpfox::getService('marketplace.process')->feature($iId, 0);					
					$this->removeClass('#js_mp_item_holder_' . $iId, 'row_featured');
				}				
				$sMessage = 'Listing(s) successfully un-featured.';
				break;
		}
		
		$this->alert($sMessage, 'Moderation', 300, 150, true);
		$this->hide('.moderation_process');			
	}		

	public function sponsorHelp()
	{
	    Phpfox::getBlock('marketplace.sponsorhelp');
	    
	}
}

?>